import org.junit.jupiter.api.Test;

import java.util.EmptyStackException;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;

public class AutoTest {

    @Test
    public void test01AutoPuedeCargarHelatodo() {
        Auto auto = new Auto();
        Helatodo helatodo = new Helatodo();

        auto.cargarSiEsPosible(helatodo);

        assertEquals(auto.descargar(), helatodo);
    }

    @Test
    public void test01AutoPuedeCargarDosHelatodo() {
        Auto auto = new Auto();
        Helatodo helatodo = new Helatodo();

        auto.cargarSiEsPosible(helatodo);
        auto.cargarSiEsPosible(helatodo);
        auto.descargar();

        assertEquals(auto.descargar(), helatodo);
    }

    @Test
    public void test03AutoNoPuedeDescargarSiEstaVacio() {
        Auto auto = new Auto();

        assertThrows(EmptyStackException.class, () -> {
            auto.descargar();
        });
    }

    @Test
    public void test04AutoNoEquipadoConPortaBiciNoPuedeCargarBici() {
        Auto auto = new Auto();
        Bici bici = new Bici();

        assertThrows(RuntimeException.class, () -> {
            auto.cargarSiEsPosible(bici);
        });
    }

    @Test
    public void test05AutoEquipadoConPortaBiciPuedeCargarBici() {
        Auto auto = new Auto();
        Bici bici = new Bici();

        auto.equipar();
        auto.cargarSiEsPosible(bici);

        assertEquals(auto.descargar(),bici);
    }


}
