import org.junit.jupiter.api.Test;

import java.util.EmptyStackException;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;

public class MotoTest {

    @Test
    public void test01MotoSePuedeCargarConHelatodo() {

        Moto moto = new Moto();
        Helatodo helatodo = new Helatodo();

        moto.cargarSiEsPosible(helatodo);

        assertEquals(moto.descargar(), helatodo);
    }
    @Test
    public void test02MotoSePuedeCargarConDosHelatodo() {

        Moto moto = new Moto();
        Helatodo helatodo = new Helatodo();

        moto.cargarSiEsPosible(helatodo);
        moto.cargarSiEsPosible(helatodo);
        moto.descargar();

        assertEquals(moto.descargar(), helatodo);
    }
    @Test
    public void test03MotoNoPuedeSerEquipadoConPortaBici() {

        Moto moto = new Moto();

        assertThrows(MotoNoPuedeSerEquipadoConPortaBiciError.class, () -> {
            moto.equipar();
        });
    }

    @Test
    public void test04MotoNoPuedeCargarBici() {

        Moto moto = new Moto();
        Bici bici = new Bici();

        assertThrows(NoPuedeSerCargadoConBiciError.class, () -> {
            moto.cargarSiEsPosible(bici);
        });
    }

    @Test
    public void test05MotoNoPuedeDescargarSiEstaVacio() {
        Moto moto = new Moto();

        assertThrows(EmptyStackException.class, () -> {
            moto.descargar();
        });
    }


}
